/*
 * The Apache Software License, Version 1.1
 *
 *
 * Copyright (c) 2002 The Apache Software Foundation.  All rights 
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:  
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "WSIF" and "Apache Software Foundation" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written 
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    nor may "Apache" appear in their name, without prior written
 *    permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation and was
 * originally based on software copyright (c) 2001, 2002, International
 * Business Machines, Inc., http://www.apache.org.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 */

package org.apache.wsif.compiler.schema.tools;

import javax.xml.namespace.QName;

/**
 * Insert the type's description here.
 * Creation date: (6/21/00 5:32:11 PM)
 * @author: Tian Zhao (tzhao@cs.purdue.edu)
 */
public class SchemaElement implements SchemaType {

    //Ignore: ID, use, nullable, abstract, final, block, default, fixed, or form
    //Ignore: annotation, unique, key, keyref

    private String name;
    private QName ref;
    private QName type;
    private boolean isArray = false;

    private SchemaType child;
    private String targetURI;

    /**
     * Insert the method's description here.
     * Creation date: (6/21/00 5:40:04 PM)
     */
    public SchemaElement(
        String name,
        QName ref,
        QName type,
        boolean isArray,
        SchemaType child,
        String targetURI) {

        this.name = name;
        this.ref = ref;
        this.type = type;
        this.isArray = isArray;
        this.child = child;
        this.targetURI = targetURI;

    }

    /**
     * Insert the method's description here.
     * Creation date: (6/21/00 6:18:04 PM)
     * @return org.apache.wsif.compiler.schema.newtools.SchemaType
     */
    public SchemaType getChild() {
        return child;
    }

    /**
     * Insert the method's description here.
     * Creation date: (6/21/00 5:41:20 PM)
     * @return int
     */
    public int getElementType() {
        return ELEMENT;
    }

    /**
     * Insert the method's description here.
     * Creation date: (6/21/00 5:42:29 PM)
     * @return java.lang.String
     */
    public String getName() {
        return name;
    }

    /**
     * Insert the method's description here.
     * Creation date: (6/21/00 5:42:49 PM)
     * @return org.apache.soap.util.xml.QName
     */
    public QName getRef() {
        return ref;
    }

    /**
     * Insert the method's description here.
     * Creation date: (6/25/00 5:06:30 PM)
     * @return java.lang.String
     */
    public String getTargetURI() {
        return targetURI;

    }

    /**
     * Insert the method's description here.
     * Creation date: (6/21/00 5:43:08 PM)
     * @return boolean
     */
    public QName getType() {
        return type;
    }

    /**
     * Insert the method's description here.
     * Creation date: (6/21/00 6:17:21 PM)
     * @return boolean
     */
    public boolean isArray() {
        return isArray;
    }
}